Index: code/trunk/data/levels/includes/weaponSettingsFPS.oxi
===================================================================
--- code/trunk/data/levels/includes/weaponSettingsFPS.oxi	(revision 8741)
+++ code/trunk/data/levels/includes/weaponSettingsFPS.oxi	(revision 8755)
@@ -17,6 +17,6 @@
         </links>
 	<Weapon>
-	   <HsW01 mode=0 munitionpershot=0 delay=0.0 material="Flares/point_lensflare" muzzleoffset=" 0.7, -0.3, -3" />
-           <LightningGun mode=1 muzzleoffset="0,0,0" />
+	   <HsW01 mode=0 munitionpershot=0 delay=0.0 damage=2.5 material="Flares/point_lensflare" muzzleoffset=" 0.7, -0.3, -3" />
+           <LightningGun mode=1 muzzleoffset="0,0,0" damage=3.14159 shielddamage=20/>
         </Weapon>
         <LaserGun
Index: code/trunk/data/levels/includes/weaponSettingsHXY.oxi
===================================================================
--- code/trunk/data/levels/includes/weaponSettingsHXY.oxi	(revision 8741)
+++ code/trunk/data/levels/includes/weaponSettingsHXY.oxi	(revision 8755)
@@ -16,10 +16,10 @@
           <HsW01 mode=0 munitionpershot=0 damage=2.5 delay=0 material="Flares/point_lensflare" />
           <HsW01 mode=0 munitionpershot=0 damage=2.5 delay=0.1 material="Flares/point_lensflare" muzzleoffset=" 0.5,0.6,1.7" />
-          <LightningGun mode=1 muzzleoffset="0,0,0" />
+          <LightningGun mode=1 muzzleoffset="0,0,0" damage=3.14159 shielddamage=20/>
         </Weapon>
         <Weapon>
           <HsW01 mode=0 munitionpershot=0 damage=2.5 delay=0  material="Flares/point_lensflare" />
           <HsW01 mode=0 munitionpershot=0 damage=2.5 delay=0.1 material="Flares/point_lensflare" muzzleoffset="-0.5,0.6,1.7" />
-          <LightningGun mode=1 muzzleoffset="0,0,0" />
+          <LightningGun mode=1 muzzleoffset="0,0,0" damage=3.14159 shielddamage=20/>
         </Weapon>
       </WeaponPack>
Index: code/trunk/data/levels/includes/weaponSettingsSwallow.oxi
===================================================================
--- code/trunk/data/levels/includes/weaponSettingsSwallow.oxi	(revision 8741)
+++ code/trunk/data/levels/includes/weaponSettingsSwallow.oxi	(revision 8755)
@@ -14,12 +14,12 @@
         </links>
         <Weapon>
-          <HsW01 mode=0 munitionpershot=0 delay=0 material="Flares/point_lensflare" />
-          <HsW01 mode=0 munitionpershot=0 delay=0.125 material="Flares/point_lensflare" muzzleoffset=" 0.5,0.6,1.7" />
-          <LightningGun mode=1 muzzleoffset="0,0,0" />
+          <HsW01 mode=0 munitionpershot=0 delay=0 damage=2.5 material="Flares/point_lensflare" />
+          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=2.5 material="Flares/point_lensflare" muzzleoffset=" 0.5,0.6,1.7" />
+          <LightningGun mode=1 muzzleoffset="0,0,0" damage=3.14159 shielddamage=20/>
         </Weapon>
         <Weapon>
-          <HsW01 mode=0 munitionpershot=0 delay=0  material="Flares/point_lensflare" />
-          <HsW01 mode=0 munitionpershot=0 delay=0.125 material="Flares/point_lensflare" muzzleoffset="-0.5,0.6,1.7" />
-          <LightningGun mode=1 muzzleoffset="0,0,0" />
+          <HsW01 mode=0 munitionpershot=0 delay=0  damage=2.5 material="Flares/point_lensflare" />
+          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=2.5 material="Flares/point_lensflare" muzzleoffset="-0.5,0.6,1.7" />
+          <LightningGun mode=1 muzzleoffset="0,0,0" damage=3.14159 shielddamage=20/>
         </Weapon>
       </WeaponPack>
Index: code/trunk/data/levels/includes/weaponSettingsTransporter.oxi
===================================================================
--- code/trunk/data/levels/includes/weaponSettingsTransporter.oxi	(revision 8741)
+++ code/trunk/data/levels/includes/weaponSettingsTransporter.oxi	(revision 8755)
@@ -14,11 +14,11 @@
         </links>
         <Weapon>
-          <HsW01 mode=0 munitionpershot=0 delay=0 material="Flares/point_lensflare" />
-          <HsW01 mode=0 munitionpershot=0 delay=0.1 material="Flares/point_lensflare" muzzleoffset=" 0.5,0.6,1.7" />
+          <HsW01 mode=0 munitionpershot=0 delay=0 damage=2.5 material="Flares/point_lensflare" />
+          <HsW01 mode=0 munitionpershot=0 delay=0.1 damage=2.5 material="Flares/point_lensflare" muzzleoffset=" 0.5,0.6,1.7" />
           <LightningGun mode=1 muzzleoffset="0,0,0" />
         </Weapon>
         <Weapon>
-          <HsW01 mode=0 munitionpershot=0 delay=0  material="Flares/point_lensflare" />
-          <HsW01 mode=0 munitionpershot=0 delay=0.1 material="Flares/point_lensflare" muzzleoffset="-0.5,0.6,1.7" />
+          <HsW01 mode=0 munitionpershot=0 delay=0  damage=2.5 material="Flares/point_lensflare" />
+          <HsW01 mode=0 munitionpershot=0 delay=0.1 damage=2.5 material="Flares/point_lensflare" muzzleoffset="-0.5,0.6,1.7" />
           <LightningGun mode=1 muzzleoffset="0,0,0" />
         </Weapon>