Index: /code/branches/ai2/data/levels/includes/weaponSettingsAssff.oxi
===================================================================
--- /code/branches/ai2/data/levels/includes/weaponSettingsAssff.oxi	(revision 8758)
+++ /code/branches/ai2/data/levels/includes/weaponSettingsAssff.oxi	(revision 8759)
@@ -23,20 +23,14 @@
             <Model mesh="LightningGun-s.mesh" pitch="78" roll="90" yaw="90" position="0.2,-1.3,0" />
             <Model mesh="hs-w01_reduced.mesh" roll="90" pitch="-76" yaw="-90" position="-1.5,1,0.3" scale=0.6 />
+            <Model mesh="LightningGun.mesh" pitch="103" roll="90" yaw="90" position="0,-1.35,0" />
+            <Model mesh="LightningGun-s.mesh" pitch="103" roll="90" yaw="90" position="0.2,-1.35,0" />
+            <Model mesh="hs-w01_reduced.mesh" roll="90" pitch="-104" yaw="-90" position="0,1.3,0.3" scale=0.6 />
           </attached>
           <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 0.1, 1.6,-2" />
           <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-1.6, 1.3,-2" />
           <LightningGun mode=1 muzzleoffset="0,0,0" damage=3.14159 shielddamage=20 />
-        </Weapon>
-        <Weapon>
-          <attached>
-            <Model mesh="LightningGun.mesh" pitch="103" roll="90" yaw="90" position="0,-1.35,0" />
-            <Model mesh="LightningGun-s.mesh" pitch="103" roll="90" yaw="90" position="0.2,-1.35,0" />
-            <Model mesh="hs-w01_reduced.mesh" roll="90" pitch="-104" yaw="-90" position="0,1.3,0.3" scale=0.6 />
-          </attached>
           <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 1.6, 1.3, -2.0" />
           <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-0.1, 1.6, -2.0" />
           <LightningGun mode=1 muzzleoffset="0,0,0" damage=23 />
-        </Weapon>
-        <Weapon>
           <SimpleRocketFire mode=2 muzzleoffset="0,0,0" damage=30 shielddamage=20 />
           <RocketFire mode=3 muzzleoffset="0,0,0" damage=30 healthdamage=50 shielddamage=20 />
Index: /code/branches/ai2/src/modules/weapons/weaponmodes/EnergyDrink.cc
===================================================================
--- /code/branches/ai2/src/modules/weapons/weaponmodes/EnergyDrink.cc	(revision 8758)
+++ /code/branches/ai2/src/modules/weapons/weaponmodes/EnergyDrink.cc	(revision 8759)
@@ -57,5 +57,4 @@
         this->delayTimer_.setTimer(1.0f, false, createExecutor(createFunctor(&EnergyDrink::shot, this)));
         this->delayTimer_.stopTimer();
-        this->setName("ENERGY_DRINK");
     }
 
Index: /code/branches/ai2/src/modules/weapons/weaponmodes/HsW01.cc
===================================================================
--- /code/branches/ai2/src/modules/weapons/weaponmodes/HsW01.cc	(revision 8758)
+++ /code/branches/ai2/src/modules/weapons/weaponmodes/HsW01.cc	(revision 8759)
@@ -60,5 +60,4 @@
 
         this->setDefaultSound("sounds/Weapon_HsW01.ogg");
-        this->setName("HSW01");
     }
 
Index: /code/branches/ai2/src/modules/weapons/weaponmodes/LaserFire.cc
===================================================================
--- /code/branches/ai2/src/modules/weapons/weaponmodes/LaserFire.cc	(revision 8758)
+++ /code/branches/ai2/src/modules/weapons/weaponmodes/LaserFire.cc	(revision 8759)
@@ -49,5 +49,4 @@
 
         this->setMunitionName("LaserMunition");
-        this->setName("LASER_FIRE");
     }
 
Index: /code/branches/ai2/src/modules/weapons/weaponmodes/LightningGun.cc
===================================================================
--- /code/branches/ai2/src/modules/weapons/weaponmodes/LightningGun.cc	(revision 8758)
+++ /code/branches/ai2/src/modules/weapons/weaponmodes/LightningGun.cc	(revision 8759)
@@ -50,5 +50,4 @@
         this->setMunitionName("LaserMunition");
         this->setDefaultSound("sounds/Weapon_LightningGun.ogg");
-        this->setName("LIGHTNING_GUN");
     }
 
Index: /code/branches/ai2/src/modules/weapons/weaponmodes/RocketFire.cc
===================================================================
--- /code/branches/ai2/src/modules/weapons/weaponmodes/RocketFire.cc	(revision 8758)
+++ /code/branches/ai2/src/modules/weapons/weaponmodes/RocketFire.cc	(revision 8759)
@@ -52,5 +52,4 @@
 
         this->setMunitionName("RocketMunition");
-        this->setName("RocketFire");
         // The firing sound of the Rocket is played in Rocket.cc (because of OpenAl sound positioning)
     }
Index: /code/branches/ai2/src/modules/weapons/weaponmodes/SimpleRocketFire.cc
===================================================================
--- /code/branches/ai2/src/modules/weapons/weaponmodes/SimpleRocketFire.cc	(revision 8758)
+++ /code/branches/ai2/src/modules/weapons/weaponmodes/SimpleRocketFire.cc	(revision 8759)
@@ -55,5 +55,4 @@
         this->setMunitionName("RocketMunition");
         this->setDefaultSoundWithVolume("sounds/Rocket_launch.ogg",0.4f);
-        this->setName("SimpleRocketFire");
         // The firing sound of the Rocket is played in Rocket.cc (because of OpenAl sound positioning)
     }